{
 Пример параллельного исполнения процедур (par2.pp).
 При отладке алгоритмов часто требуется контролировать
 в реальном времени значения различных датчиков.
 Параллельная процедура p_show выводит значение
 уровня отраженного света дачика цвета в указанную позицию 
 на экране EV3, периодически его обновляя. Программа
 использует одновремнно две таких процедуры, для первого и второго
 датчиков цвета.
}
{$mode objfpc}
uses uev3,rubiroScreen,rubiroSensors,rubiroParallel;
{
 В параллельную процедуру передаются 4 параметра: координаты вывода x,y,
 объект датчика цвета и указатель на стоп-переменную.
}
procedure p_show(args:array of const);
 var x,y:integer; c:TEv3ColorSensor;
     stop:pboolean; s:string=''; ref:integer;
 begin
  // Заполняем локальные переменные из содержимого константного массива
  x:=toInt(args[0]); y:=toInt(args[1]);
  c:=ev3Color(args[2]); stop:=toPointer(args[3]);
  {
   Устанавливаем в белый цвет карандаш и кисть для будущей
   очистки области вывода значения датчика
  }
  ev3Screen.brushSolid.brushWhite.penWhite;
  {
   Выполняем цикл, пока основная программа не установит 
   стоп-переменную в истину
  }
  while not stop^ do begin
   ref:=c.reflect;
   {
    Cтираем старое значение датчика и выводим новое, предварительно
    захватив мьютекс. Если не использовать мьютекс, то другая
    параллельная процедура может вывести содержимое холста
    во время его обновления текущей процедурой, что приведет
    к мерцанию экрана.
   }
   ev3.lock;
   // Очищаем экран в области вывода старого значения датчика
   with ev3screen.boundText(x,y,s) do
    ev3screen.rectangle(left,top,right,bottom);
   s:=toStr(ref);
   // Выводим новое зачение датчика
   ev3screen.print(x,y,s).show;
   ev3.unlock;
  end;
  {
   По завершению работы очищаем экран в области вывода
   параллельной процедуры
  }
  with ev3screen.boundText(x,y,s) do
   ev3screen.rectangle(left,top,right,bottom).show;
 end;

 var stop:boolean=false;
begin
 ev3init();
 parallel(@p_show,[10,20,ev3color1,@stop]);
 parallel(@p_show,[10,40,ev3color2,@stop]);
 readln;
 stop:=true;
 readln;
end.
