{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Модуль параллелизации исполнения кода

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$I uev3defines.inc}
unit rubiroParallel;

interface
 uses cthreads,uev3,variants,unix;

    // допустимые типы параллельных процедур
 Type
  TParallelProcV0=procedure();
  TParallelProcV1=procedure(v1:variant);
  TParallelProcV2=procedure(v1,v2:variant);
  TParallelProcV3=procedure(v1,v2,v3:variant);
  TParallelProcV4=procedure(v1,v2,v3,v4:variant);
  TParallelProcV5=procedure(v1,v2,v3,v4,v5:variant);
  TParallelProcVA=procedure(VA: array of const);
  TParallelMethod=procedure(VA: array of const) of object;

     // параллельный вызов, возвращает ID задачи
 function parallel(proc:TParallelProcV0):dword;
 function parallel(proc:TParallelProcV1; V1:variant):dword;
 function parallel(proc:TParallelProcV2; V1,V2:variant):dword;
 function parallel(proc:TParallelProcV3; V1,V2,V3:variant):dword;
 function parallel(proc:TParallelProcV4; V1,V2,V3,V4:variant):dword;
 function parallel(proc:TParallelProcV5; V1,V2,V3,V4,V5:variant):dword;
 function parallel(proc:TParallelProcVA; VA:array of const):dword;

    // параллельный вызов для метода класса
 function parallel(proc:TParallelMethod; VA:array of const):dword;

 // Ожидание завершения параллельной задачи
 procedure parallelWait(id:dword);

 // Завершение параллельной задачи
 // ВНИМАНИЕ! КРАЙНЕ ОПАСНО! МОЖНО ЗАВЕСИТЬ ПРОГРАММУ!
 procedure parallelStop(id:dword);

implementation

uses
  SysUtils,uev3devices,pthreads;

var Threads:array of dword=nil;

procedure storeThread(id:dword);
  var i:integer;
 begin
  for i:=0 to length(threads)-1 do
   if threads[i]=0 then begin
      threads[i]:=id;
      exit;
   end;
  setlength(threads,length(threads)+1);
  threads[length(threads)-1]:=id;
 end;

procedure clearThread(id:dword);
  var i:integer;
 begin
  for i:=0 to length(threads)-1 do
   if threads[i]=id then begin
      threads[i]:=0;
      exit;
   end;
 end;

type
 PParallelData=^TParallelData;
 TParallelData=record
   paramcount:integer;
   proc:pointer;
   objproc:TParallelMethod;
   VA:array of TVarRec;
 end;

function ThreadSimple(proc: pointer):PtrInt;
 var p:pparalleldata absolute proc; i:integer;
begin
 // средство мгновенного убиения нити извне
 pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS,nil);
 result:=0;
 try
  try
   // был красивый вариант с передачей большего числа параметров, чем объявлено в процедуре
   // но надежды на него нет, вариант работает только если вызов по умолчанию cdecl
   // Это так для ARM и x86-64 и не так для x86. Фича недокументирована, в любой новой
   // версии компилятора может быть изменена. Или не изменена. Поэтому отказываемся от нее.
   // WD(p^.paramcount);
   case p^.paramcount of
    0: TParallelProcV0(p^.proc)();
    1: TParallelProcV1(p^.proc)(p^.va[0].VVariant^);
    2: TParallelProcV2(p^.proc)(p^.va[0].VVariant^,p^.va[1].VVariant^);
    3: TParallelProcV3(p^.proc)(p^.va[0].VVariant^,p^.va[1].VVariant^,p^.va[2].VVariant^);
    4: TParallelProcV4(p^.proc)(p^.va[0].VVariant^,p^.va[1].VVariant^,p^.va[2].VVariant^,p^.va[3].VVariant^);
    5: TParallelProcV5(p^.proc)(p^.va[0].VVariant^,p^.va[1].VVariant^,p^.va[2].VVariant^,p^.va[3].VVariant^,p^.va[4].VVariant^);
    100: TParallelProcVA(p^.proc)(p^.va);
    200: p^.objproc(p^.va);
   end;
  except
    if not ev3finalized then raise;
  end;
 finally
  // выделенную в inParallel память надо отдать обратно
  for i:=low(p^.va) to high(p^.va) do if p^.va[i].VType=vtVariant then dispose(p^.va[i].VVariant);
  dispose(p);
 end;
end;

function inParallel(paramcount:integer; proc: pointer; objproc:TParallelMethod; VA: array of const): dword;
var p:pparalleldata; i:integer; v:pVariant;
begin
new(p);
p^.paramcount:=paramcount;
p^.proc:=proc;
p^.objproc:=objproc;
setlength(p^.va,length(va));
for i:=low(va) to high(va) do begin
 // делаем копии параметров вариантных, строковых, целочисленных и вещественных, всем выделяем память;
 // что-бы избавиться от ссылок.
 p^.VA[i]:=VA[i];
 if isInt(p^.VA[i]) then begin
   new(v);
   v^:=toInt(p^.VA[i]);
   p^.va[i].vVariant:=v;
   p^.va[i].VType:=vtVariant;
 end else
 if p^.VA[i].vType=vtVariant then begin
   new(v);
   v^:=p^.VA[i].VVariant^;
   p^.VA[i].VVariant:=v;
 end else
 if isStr(p^.VA[i]) then begin
   new(v);
   v^:=toStr(p^.VA[i]);
   p^.va[i].vVariant:=v;
   p^.va[i].VType:=vtVariant;
 end else
 if isReal(p^.VA[i]) then begin
   new(v);
   v^:=toReal(p^.VA[i]);
   p^.va[i].vVariant:=v;
   p^.va[i].VType:=vtVariant;
 end;
end;
result:=beginThread(@ThreadSimple,p);
storeThread(result);
end;

function parallel(proc: TParallelProcV0):dword;
begin
 result:=inParallel(0,proc,nil,[Null,Null,Null,Null,Null]);
end;

function parallel(proc: TParallelProcV1; V1: variant): dword;
begin
 result:=inParallel(1,proc,nil,[V1,Null,Null,Null,Null]);
end;

function parallel(proc: TParallelProcV2; V1, V2: variant): dword;
begin
 result:=inParallel(2,proc,nil,[V1, V2, Null, Null, Null]);
end;

function parallel(proc: TParallelProcV3; V1, V2, V3: variant): dword;
begin
 result:=inParallel(3,proc,nil,[V1, V2, V3, Null, Null]);
end;

function parallel(proc: TParallelProcV4; V1, V2, V3, V4: variant): dword;
begin
 result:=inParallel(4,proc,nil,[V1, V2, V3, V4, Null]);
end;

function parallel(proc: TParallelProcV5; V1, V2, V3, V4, V5: variant): dword;
begin
 result:=inParallel(5,proc,nil,[V1, V2, V3, V4, V5]);
end;

function parallel(proc: TParallelProcVA; VA: array of const): dword;
begin
 result:=inParallel(100,proc,nil,va);
end;

function parallel(proc: TParallelMethod; VA: array of const): dword;
begin
 result:=inParallel(200,nil,proc,va);
end;

procedure parallelStop(id: dword);
begin
  system.killThread(id);
  //pthread_cancel(pthread_t(id));
end;

procedure parallelWait(id: dword);
begin
  WaitForThreadTerminate(id,0);
  clearThread(id);
end;

procedure parallelDone;
 var i:integer;
begin
 for i:=0 to length(threads)-1 do if threads[i]<>0 then parallelStop(threads[i]);
 // после убиения нитей ожидание их завершения не требуется.
 // однако оставим на случай, если в будущем изменится концепция.
 for i:=0 to length(threads)-1 do begin
   if threads[i]<>0 then parallelWait(threads[i]);
 end;
end;

initialization
 firstDone:=@parallelDone;
end.