{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Заголовки функций преобразований типов
    для модуля uev3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

 {
    Правила преобразования:
    0. Поддерживаются следующие псевдотипы:
     0.1 Int: 8-байтовое целое, тип int64 во FreePascal
         преобразуется из всех целочисленных и беззнаковых типов FreePascal
     0.2 Real: 8-байтовое вещественное, тип double во FreePascal
         преобразуется из всех вещественных типов FreePascal
     0.3 Str: длинная строка, тип AnsiString во FreePascal
         преобразуется из всех строковых и символьных типов FreePascal
     0.4 Bool: логический тип, тип Boolean во FreePascal
         преобразуется из всех логических типов FreePascal
     0.5 Object: экземпляр класса во FreePascal
     0.6 Class: метакласс во FreePascal
     0.7 Pointer: произвольный указатель
    
    1. !!! Все без исключения преобразуется, из любого поддерживаемого типа в любой другой
     поддерживаемый тип. !!!
    
    2. Преобразование в Integer
     2.1. Из Integer - без изменений
     2.2. Из Real - с округлением
     2.3. Из String, в виде любого числа - в это число, в случае вещественного - с округлением (Round)
     2.4. Из String, все остальное - в нуль
     2.5. Из Boolean, true - в единицу, false - в нуль
     2.6. Из Object, существующий - в единицу, nil - в нуль
     2.7. Из Class - существующий - в единицу, nil - в нуль
     2.8. Из Pointer - числовым знаковым значением.
     2.9. Во всех остальных случаях - в нуль
    3. Преобразование в Real
     3.1. Из Integer - с добавлением дробной части
     3.2. Из Real - без изменений
     3.3. Из String, в виде любого числа - в это число
     3.4. Из String, все остальное - в 0.0
     3.5. Из Boolean, true - в 1.0, false - в 0.0
     3.6. Из Object, существующий - в 1.0, nil - в 0.0
     3.7. Из Class - существующий - в 1.0, nil - в 0.0
     3.8. Из Pointer - числовым знаковым значением.
     3.9. Во всех остальных случаях - в 0.0
    4. Преобразование в String
     4.1. Из Integer - из числа в строку, десятичный формат
     4.2. Из Real - из числа в строку, до 6 знаков после десятичной точки
     4.3. Из String без изменений
     4.4. Из Boolean - в 'TRUE' или 'FALSE'
     4.5. Из Object, существующий - в имя класса, nil - в пустую строку
     4.6. Из Class - существующий - в имя класса, nil - в пустую строку
     4.7. Из Pointer - числовым знаковым значением в строку.
     4.8. Во всех остальных случаях - в пустую строку
    5. Преобразование в Boolean
     5.1. Из Integer, 0 - в true, остальное - в false
     5.2. Из Real, 0.0 - в true, остальное - в false
     5.3. Из String, в виде нулевого числового значения (0, 0.0, 0.000 и т.п.) - в false
     5.4. Из String, пустая строка, 'false','no','ложь','нет' в любом регистре - в false
     5.5. Из String, все остальное - в true
     5.6. Из Boolean, без изменений
     5.7. Из Object, существующий - в true, nil - в false
     5.8. Из Class - существующий - в true, nil - в false
     5.9. Из Pointer - nil в false, остальное - в true
     5.10. Во всех остальных случаях - в false
    6. Преобразование в Object
     6.1. Из Object, без изменений
     6.2. Во всех остальных случаях - в nil
    7. Преобразование в Class
     7.1. Из Object, в класс объекта
     7.2. Из Class, без изменений
     7.3. Во всех остальных случаях - нулевое значение в nil, ненулевое - в TObject
    8. Преобразование в Pointer
     8.1. Из Integer - прямым преобразованием
     8.2. Из Real -> Integer -> Pointer
     8.3. Из String -> Integer -> Pointer
     8.4. Из Object, прямым преобразованием
     8.5. Из Pointer - без изменений.
     8.6. Во всех остальных случаях - в nil
}

 // проверка на тип данных вариантов и аргументов константного массива
 function isInt(arg:TVarRec):boolean;
 function isInt(arg:variant):boolean;
 function isReal(arg:TVarRec):boolean;
 function isReal(arg:variant):boolean;
 function isStr(arg:TVarRec):boolean;
 function isStr(arg:variant):boolean;
 function isBool(arg:TVarRec):boolean;
 function isBool(arg:variant):boolean;
 function isObject(arg:TVarRec):boolean;
 function isObject(arg:variant):boolean;
 function isClass(arg:TVarRec):boolean;
 function isClass(arg:variant):boolean;
 function isPointer(arg:TVarRec):boolean;
 function isPointer(arg:variant):boolean;

 // перевод аргумента константного массива в различные типы данных
 function toInt(arg:TVarRec):int64;
 function toInt(arg:variant):int64;
 function toInt(arg:int64):int64;
 function toInt(arg:double):int64;
 function toInt(arg:string):int64;
 function toInt(arg:boolean):int64;
 function toInt(arg:TObject):int64;
 function toInt(arg:TClass):int64;
 function toInt(arg:pointer):int64;

 function toReal(arg:TVarRec):double;
 function toReal(arg:variant):double;
 function toReal(arg:int64):double;
 function toReal(arg:double):double;
 function toReal(arg:string):double;
 function toReal(arg:boolean):double;
 function toReal(arg:TObject):double;
 function toReal(arg:TClass):double;
 function toReal(arg:pointer):double;

 function toStr(arg:TVarRec):string;
 function toStr(arg:variant):string;
 function toStr(arg:int64):string;
 function toStr(arg:double):string;
 function toStr(arg:string):string;
 function toStr(arg:boolean):string;
 function toStr(arg:TObject):string;
 function toStr(arg:TClass):string;
 function toStr(arg:pointer):string;

 function toBool(arg:TVarRec):boolean;
 function toBool(arg:variant):boolean;
 function toBool(arg:int64):boolean;
 function toBool(arg:double):boolean;
 function toBool(arg:string):boolean;
 function toBool(arg:boolean):boolean;
 function toBool(arg:TObject):boolean;
 function toBool(arg:TClass):boolean;
 function toBool(arg:pointer):boolean;

 function toObject(arg:TVarRec):TObject;
 function toObject(arg:variant):TObject;
 function toObject(arg:int64):TObject;
 function toObject(arg:double):TObject;
 function toObject(arg:string):TObject;
 function toObject(arg:boolean):TObject;
 function toObject(arg:TObject):TObject;
 function toObject(arg:TClass):TObject;
 function toObject(arg:pointer):TObject;

 function toClass(arg:TVarRec):TClass;
 function toClass(arg:variant):TClass;
 function toClass(arg:int64):TClass;
 function toClass(arg:double):TClass;
 function toClass(arg:string):TClass;
 function toClass(arg:boolean):TClass;
 function toClass(arg:TObject):TClass;
 function toClass(arg:TClass):TClass;
 function toClass(arg:pointer):TClass;

 function toPointer(arg:TVarRec):pointer;
 function toPointer(arg:variant):pointer;
 function toPointer(arg:int64):pointer;
 function toPointer(arg:double):pointer;
 function toPointer(arg:string):pointer;
 function toPointer(arg:boolean):pointer;
 function toPointer(arg:TObject):pointer;
 function toPointer(arg:TClass):pointer;
 function toPointer(arg:pointer):pointer;

